QoS-Update - Komplette grafische Ueberarbeitung
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
15679d9f 20# Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
15679d9f
MT
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
5bd13f01 27VERSION="2.0b" # Version number
8e2e5cf3 28SLOGAN="www.ipfire.org" # Software slogan
15679d9f
MT
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
857d9bf2 31MAX_RETRIES=1 # prefetch/check loop
15679d9f
MT
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
03ad5f93
MT
36IPFVER="full" # Which version should be compiled? (full|light|voice)
37
38# Set an information about the build number
15679d9f
MT
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
df5e82b3 45 FULLPATH=`which $0`
15679d9f 46else
df5e82b3
MT
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
15679d9f 53fi
df5e82b3 54
15679d9f
MT
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 62
15679d9f
MT
63# Include funtions
64. tools/make-functions
df5e82b3 65
15679d9f
MT
66if [ -f .config ]; then
67 . .config
68else
6b8cff41
MT
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
15679d9f 76fi
df5e82b3
MT
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
9b0ff0a0 106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
df5e82b3
MT
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
15679d9f 109 beautify message FAIL
df5e82b3 110 exiterror "Failed to set correct nice level"
15679d9f
MT
111 else
112 beautify message DONE
df5e82b3
MT
113 fi
114
15679d9f 115
df5e82b3
MT
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
9b0ff0a0 121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
df5e82b3 122 if [ `id -u` != 0 ]; then
15679d9f 123 beautify message FAIL
df5e82b3 124 exiterror "Not building as root"
15679d9f
MT
125 else
126 beautify message DONE
df5e82b3
MT
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
9b0ff0a0 135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
df5e82b3
MT
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
41921bd9 138 if (( 2048000 > $BASE_ASPACE )); then
df5e82b3 139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
41921bd9 140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
15679d9f 141 beautify message FAIL
41921bd9 142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
df5e82b3 143 fi
15679d9f
MT
144 else
145 beautify message DONE
df5e82b3
MT
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
df5e82b3
MT
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
fcb5057d 173 MAKETUNING="-j12"
dd714b8a 174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
df5e82b3
MT
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
90d372c4 179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
df5e82b3 180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
90d372c4
MT
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
df5e82b3
MT
185
186 # Make all sources and proc available under lfs build
90d372c4 187 mount --bind /dev $BASEDIR/build/dev
857d9bf2
MT
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
df5e82b3
MT
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
119ee469 202 # This is a temporary hack!!!
6b8cff41
MT
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
119ee469 206
df5e82b3
MT
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
df5e82b3
MT
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
df5e82b3
MT
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
15679d9f
MT
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
df5e82b3 224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
dd714b8a
MT
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
9b0ff0a0 227 lfsmake1 cleanup-toolchain PASS=1
df5e82b3
MT
228 lfsmake1 tcl
229 lfsmake1 expect
df5e82b3 230 lfsmake1 dejagnu
15679d9f
MT
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
dd714b8a
MT
233 lfsmake1 ncurses
234 lfsmake1 bash
df5e82b3 235 lfsmake1 bzip2
dd714b8a 236 lfsmake1 coreutils
df5e82b3
MT
237 lfsmake1 diffutils
238 lfsmake1 findutils
dd714b8a 239 lfsmake1 gawk
df5e82b3 240 lfsmake1 gettext
dd714b8a
MT
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
df5e82b3 245 lfsmake1 patch
dd714b8a
MT
246 lfsmake1 perl
247 lfsmake1 sed
df5e82b3
MT
248 lfsmake1 tar
249 lfsmake1 texinfo
df5e82b3 250 lfsmake1 util-linux
9b0ff0a0 251 lfsmake1 cleanup-toolchain PASS=2
df5e82b3
MT
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
df5e82b3 258 lfsmake2 stage2
9b0ff0a0 259 lfsmake2 linux-libc-header
df5e82b3
MT
260 lfsmake2 man-pages
261 lfsmake2 glibc
9b0ff0a0 262 lfsmake2 cleanup-toolchain PASS=3
df5e82b3
MT
263 lfsmake2 binutils
264 lfsmake2 gcc
9b0ff0a0 265 lfsmake2 berkeley
df5e82b3 266 lfsmake2 coreutils
df5e82b3 267 lfsmake2 iana-etc
df5e82b3
MT
268 lfsmake2 m4
269 lfsmake2 bison
9b0ff0a0
MT
270 lfsmake2 ncurses
271 lfsmake2 procps
df5e82b3 272 lfsmake2 sed
9b0ff0a0 273 lfsmake2 libtool
df5e82b3 274 lfsmake2 perl
9b0ff0a0
MT
275 lfsmake2 readline
276 lfsmake2 zlib
df5e82b3
MT
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
df5e82b3
MT
280 lfsmake2 bzip2
281 lfsmake2 diffutils
df5e82b3 282 lfsmake2 e2fsprogs
65998e0a 283 lfsmake2 ed
9b0ff0a0
MT
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
15679d9f 287 lfsmake2 grub
9b0ff0a0
MT
288 lfsmake2 gawk
289 lfsmake2 gettext
290 lfsmake2 grep
291 lfsmake2 groff
df5e82b3 292 lfsmake2 gzip
9b0ff0a0
MT
293 lfsmake2 inetutils
294 lfsmake2 iproute2
295 lfsmake2 kbd
296 lfsmake2 less
df5e82b3 297 lfsmake2 make
9b0ff0a0
MT
298 lfsmake2 man
299 lfsmake2 mktemp
df5e82b3 300 lfsmake2 modutils
65998e0a 301 lfsmake2 net-tools
df5e82b3 302 lfsmake2 patch
df5e82b3
MT
303 lfsmake2 psmisc
304 lfsmake2 shadow
305 lfsmake2 sysklogd
306 lfsmake2 sysvinit
307 lfsmake2 tar
90d372c4
MT
308 lfsmake2 texinfo
309 lfsmake2 udev
df5e82b3 310 lfsmake2 util-linux
90d372c4 311 lfsmake2 vim
df5e82b3
MT
312}
313
15679d9f 314buildipfire() {
907cd036 315 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 316 export LOGFILE
15679d9f
MT
317 ipfiremake configroot
318 ipfiremake dhcp
319 ipfiremake dhcpcd
320 ipfiremake libusb
321 ipfiremake libpcap
a10ae6cc 322 ipfiremake linux-atm
15679d9f
MT
323 ipfiremake ppp
324 ipfiremake rp-pppoe
325 ipfiremake unzip
3a1019f6 326 ipfiremake linux SMP=1
552b817b 327 ipfiremake ipp2p SMP=1
05207d69
MT
328 ipfiremake fcdsl SMP=1
329 ipfiremake fcdsl2 SMP=1
330 ipfiremake fcdslsl SMP=1
331 ipfiremake fcdslusb SMP=1
332 ipfiremake fcdslslusb SMP=1
333 ipfiremake fcpci SMP=1
a10ae6cc 334# ipfiremake promise-sata-300-tx SMP=1
dd001658 335 ipfiremake zaptel SMP=1
c3e36980 336 ipfiremake linux
552b817b 337 ipfiremake ipp2p
05207d69
MT
338 ipfiremake fcdsl
339 ipfiremake fcdsl2
340 ipfiremake fcdslsl
341 ipfiremake fcdslusb
342 ipfiremake fcdslslusb
343 ipfiremake fcpci
f59e1e88 344# ipfiremake promise-sata-300-tx
119f6ad3 345 ipfiremake zaptel
15679d9f
MT
346 ipfiremake expat
347 ipfiremake gdbm
348 ipfiremake gmp
c8ead4a5 349 ipfiremake pam
15679d9f
MT
350 ipfiremake openssl
351 ipfiremake python
352 ipfiremake libnet
ddac6087 353 ipfiremake libjpeg
15679d9f
MT
354 ipfiremake libpng
355 ipfiremake libtiff
15679d9f
MT
356 ipfiremake lcms
357 ipfiremake libmng
358 ipfiremake freetype
fd3e7da0 359 ipfiremake libart
15679d9f
MT
360 ipfiremake gd
361 ipfiremake popt
411afd1f 362 ipfiremake pcre
15679d9f
MT
363 ipfiremake slang
364 ipfiremake newt
fd3e7da0 365 ipfiremake libcap
15679d9f 366 ipfiremake pciutils
15679d9f 367 ipfiremake libxml2
6b8cff41 368 ipfiremake BerkeleyDB
15679d9f 369 ipfiremake mysql
411afd1f 370 ipfiremake cyrus-sasl
15679d9f
MT
371 ipfiremake openldap
372 ipfiremake apache2
373 ipfiremake php
a10ae6cc 374 ipfiremake apache2 PASS=C
15679d9f
MT
375 ipfiremake arping
376 ipfiremake beep
377 ipfiremake bind
378 ipfiremake capi4k-utils
379 ipfiremake cdrtools
380 ipfiremake dnsmasq
381 ipfiremake dosfstools
72d80898 382 ipfiremake reiserfsprogs
26ec9513 383 ipfiremake squashfstools
15679d9f
MT
384 ipfiremake ethtool
385 ipfiremake ez-ipupdate
386 ipfiremake fcron
7b9e5f10 387 ipfiremake GD
15679d9f
MT
388 ipfiremake gnupg
389 ipfiremake hdparm
390 ipfiremake ibod
391 ipfiremake initscripts
392 ipfiremake iptables
552b817b 393 ipfiremake ipp2p IPT=1
15679d9f
MT
394 ipfiremake ipac-ng
395 ipfiremake ipaddr
15679d9f 396 ipfiremake iptstate
fd3e7da0 397 ipfiremake iputils
15679d9f 398 ipfiremake l7-protocols
a10ae6cc 399 ipfiremake isapnptools
fe6d84cb 400# ipfiremake isdn4k-utils # What about mISDN???
72d80898 401 ipfiremake kudzu
15679d9f
MT
402 ipfiremake logrotate
403 ipfiremake logwatch
15679d9f
MT
404 ipfiremake misc-progs
405 ipfiremake mtools
406 ipfiremake nano
407 ipfiremake nash
408 ipfiremake nasm
409 ipfiremake URI
410 ipfiremake HTML-Tagset
411 ipfiremake HTML-Parser
412 ipfiremake Compress-Zlib
413 ipfiremake Digest
414 ipfiremake Digest-SHA1
415 ipfiremake Digest-HMAC
416 ipfiremake libwww-perl
417 ipfiremake Net-DNS
418 ipfiremake Net-IPv4Addr
419 ipfiremake Net_SSLeay
420 ipfiremake IO-Stringy
421 ipfiremake Unix-Syslog
422 ipfiremake Mail-Tools
423 ipfiremake MIME-Tools
424 ipfiremake Net-Server
425 ipfiremake Convert-TNEF
426 ipfiremake Convert-UUlib
427 ipfiremake Archive-Tar
428 ipfiremake Archive-Zip
429 ipfiremake Text-Tabs+Wrap
430 ipfiremake Locale-Country
431 ipfiremake GeoIP
432 ipfiremake fwhits
433 ipfiremake noip_updater
434 ipfiremake ntp
435 ipfiremake oinkmaster
436 ipfiremake openssh
437 ipfiremake openswan
438 ipfiremake pptpclient
439 ipfiremake rrdtool
440 ipfiremake setserial
441 ipfiremake setup
442 ipfiremake snort
443 ipfiremake squid
444 ipfiremake squid-graph
445 ipfiremake squidguard
6f00de0d 446 ipfiremake tcpdump
15679d9f
MT
447 ipfiremake traceroute
448 ipfiremake vlan
449 ipfiremake wireless
450 ipfiremake libsafe
451 ipfiremake 3c5x9setup
452 ipfiremake pakfire
15679d9f
MT
453 ipfiremake java
454 ipfiremake bootsplash
455 ipfiremake spandsp
456 ipfiremake lzo
457 ipfiremake openvpn
458 ipfiremake pkg-config
459 ipfiremake glib
15679d9f 460 ipfiremake pammysql
15679d9f
MT
461 ipfiremake xinetd
462 ipfiremake ghostscript
463 ipfiremake cups
464 ipfiremake samba
465 ipfiremake sudo
466 ipfiremake mc
467 ipfiremake wget
468 ipfiremake wput
469 ipfiremake bridge-utils
470 ipfiremake screen
471 ipfiremake hddtemp
472 ipfiremake smartmontools
473 ipfiremake htop
474 ipfiremake lynx
475 ipfiremake postfix
476 ipfiremake procmail
477 ipfiremake fetchmail
478 ipfiremake cyrusimap
479 ipfiremake webcyradm
480 ipfiremake mailx
481 ipfiremake clamav
482 ipfiremake razor
483 ipfiremake spamassassin
fd3e7da0 484 ipfiremake amavisd
15679d9f 485 ipfiremake stund
15679d9f 486 ipfiremake libpri
119f6ad3 487# ipfiremake bristuff
15679d9f
MT
488 ipfiremake asterisk
489 ipfiremake mpg123
490 ipfiremake libmad
491 ipfiremake libogg
492 ipfiremake libvorbis
493 ipfiremake lame
494 ipfiremake xvid
495 ipfiremake mpeg2dec
496 ipfiremake ffmpeg
497 ipfiremake sox
498 ipfiremake gnump3d
499 ipfiremake videolan
500 ipfiremake applejuice
501 ipfiremake ocaml
502 ipfiremake mldonkey
503 ipfiremake ntop
504 ipfiremake rsync
505 ipfiremake tcpwrapper
506 ipfiremake portmap
507 ipfiremake nfs
508 ipfiremake nmap
509 ipfiremake mbmon
510 ipfiremake iftop
511 ipfiremake ncftp
512 ipfiremake cftp
513 ipfiremake etherwake
514 ipfiremake ethereal
515 ipfiremake tftp-hpa
516 ipfiremake iptraf
517 ipfiremake nagios
518 ipfiremake yasuc
df5e82b3
MT
519}
520
521buildinstaller() {
522 # Run installer scripts one by one
523 LOGFILE="$BASEDIR/log/_build.installer.log"
524 export LOGFILE
0afc6d83 525 ipfiremake syslinux
fd0763dc 526 ipfiremake memtest
bc9f0c12
MT
527 installmake linux-libc-header
528 installmake binutils
529 ipfiremake uClibc PASS=1
530 ipfiremake gcc INST=1
531 installmake uClibc PASS=2
532 installmake gcc INST=2
533 installmake uClibc PASS=3
df5e82b3 534 installmake busybox
c66941dd 535 installmake udev
33634aa8
MT
536 installmake slang
537 installmake newt
72d80898 538 installmake gettext
33634aa8
MT
539 installmake kbd
540 installmake popt
33634aa8 541 installmake sysvinit
df5e82b3 542 installmake misc-progs
33634aa8
MT
543 installmake e2fsprogs
544 installmake reiserfsprogs
a6316ce4 545 installmake sysfsutils
df5e82b3 546 installmake util-linux
df5e82b3 547 installmake pciutils
fcb5057d 548 installmake kudzu
df5e82b3 549 installmake installer
df5e82b3 550 installmake initrd
df5e82b3
MT
551}
552
553buildpackages() {
554 LOGFILE="$BASEDIR/log/_build.packages.log"
555 export LOGFILE
556 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 557
edd536b6 558 installmake strip
df5e82b3
MT
559
560 # Generating list of packages used
0fbb45e9 561 echo -n "Generating packages list from logs" | tee -a $LOGFILE
df5e82b3
MT
562 rm -f $BASEDIR/doc/packages-list
563 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
564 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 565 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
566 fi
567 done
7471f6ab 568 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
0fbb45e9 569 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
df5e82b3
MT
570 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
571 rm -f $BASEDIR/doc/packages-list
c9673262 572 # packages-list.txt is ready to be displayed for wiki page
0fbb45e9 573 beautify message DONE
df5e82b3 574
9607771a 575 # Create images for install
15679d9f 576 ipfiremake cdrom
33634aa8 577 ipfiremake pxe
fcb5057d 578 cp -f $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
c9673262 579
72d80898 580# ipfirepackages
e67a57fe
MT
581
582 # Cleanup
583 stdumount
584 rm -rf $BASEDIR/build/tmp/*
585
586 # Generating total list of files
fd0763dc 587 echo "Generating files list from logs" | tee -a $LOGFILE
e67a57fe
MT
588 rm -f $BASEDIR/log/FILES
589 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
590 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
591 echo "##" >>$BASEDIR/log/FILES
592 echo "## `basename $i`" >>$BASEDIR/log/FILES
593 echo "##" >>$BASEDIR/log/FILES
594 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
595 fi
596 done
913668ba 597 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
5e773594 598 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
e67a57fe
MT
599
600 cd $PWD
601
602}
603
604ipfirepackages() {
013a23e2
MT
605 if [ -d "$BASEDIR/packages" ]; then
606 for i in `ls $BASEDIR/packages`; do
607 touch $BASEDIR/build/install/packages/$i.empty
608 done
609 fi
f1baee3e 610# ipfiredist amavisd
78331e30 611 ipfiredist applejuice
5ac2da9f 612 ipfiredist asterisk
c7acba4a 613 ipfiredist clamav
483f59cd 614 ipfiredist cups
78331e30
MT
615 ipfiredist cyrusimap
616 ipfiredist fetchmail
d1b6aa72 617 ipfiredist ffmpeg
78331e30 618 ipfiredist gnump3d
7a98bae5 619 ipfiredist iptraf
0d0521b6 620 ipfiredist java
78331e30 621 ipfiredist lame
d1b6aa72 622 ipfiredist libmad
ae179f6e 623 ipfiredist libogg
ae179f6e 624 ipfiredist libvorbis
f0ca8c34 625 ipfiredist mailx
3ab910dd 626 ipfiredist mldonkey
d1b6aa72 627 ipfiredist mpeg2dec
2ae94d2d 628 ipfiredist nagios
f0ca8c34
MT
629 ipfiredist nfs
630 ipfiredist nmap
3e45cc09 631 ipfiredist ntop
27ac55bf 632 ipfiredist portmap
78331e30 633 ipfiredist postfix
371d9df0 634 ipfiredist procmail
90350ff3 635 ipfiredist samba
ae179f6e 636 ipfiredist sox
f0ca8c34 637 ipfiredist spamassassin
7a98bae5 638 ipfiredist subversion
d1b6aa72 639 ipfiredist videolan
f1baee3e 640 ipfiredist webcyradm
d1b6aa72 641 ipfiredist xvid
0145f271 642 ipfiredist yasuc
78331e30 643 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
d535503d 644 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 645 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
646}
647
648# See what we're supposed to do
649case "$1" in
650build)
9729e787 651 clear
df5e82b3 652 BUILDMACHINE=`uname -m`
712d859c 653 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
df5e82b3 654 #only restore on a clean disk
9b0ff0a0 655 if [ ! -f log/cleanup-toolchain-2-tools ]; then
df5e82b3 656 if [ ! -n "$PACKAGE" ]; then
15679d9f 657 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
658 prepareenv
659 buildtoolchain
660 else
661 PACKAGENAME=${PACKAGE%.tar.gz}
15679d9f 662 beautify build_stage "Packaged toolchain compilation"
df5e82b3
MT
663 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
664 tar zxf $PACKAGE
665 prepareenv
666 else
667 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
668 fi
669 fi
670 else
9729e787
MT
671 echo -n "Using installed toolchain" | tee -a $LOGFILE
672 beautify message SKIP
df5e82b3
MT
673 prepareenv
674 fi
5cfe86e6 675
7ab7a9b4 676 beautify build_start
0b59f25c 677 beautify build_stage "Building LFS"
df5e82b3 678 buildbase
15679d9f 679
0b59f25c 680 beautify build_stage "Building IPFire"
15679d9f 681 buildipfire
5cfe86e6
HS
682
683 # Setzen des IPFire Builds
8af06406 684 if [ "$FIREBUILD" ]; then
e57bc1fd 685 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6 686 else
e57bc1fd 687 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6
HS
688 fi
689
0b59f25c 690 beautify build_stage "Building installer"
df5e82b3 691 buildinstaller
15679d9f 692
0b59f25c 693 beautify build_stage "Building packages"
df5e82b3 694 buildpackages
7ab7a9b4 695 beautify build_end
df5e82b3
MT
696 ;;
697shell)
698 # enter a shell inside LFS chroot
699 # may be used to changed kernel settings
700 prepareenv
701 entershell
702 ;;
703changelog)
d1dd6669 704 echo -n "Loading new Changelog from SVN: "
f9315063 705 svn log http://svn.ipfire.eu/svn/ipfire > doc/ChangeLog
a50d04ab 706 beautify message DONE
df5e82b3 707 ;;
df5e82b3 708clean)
a50d04ab 709 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
df5e82b3
MT
710 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
711 $LOSETUP -d $i 2>/dev/null
712 done
713 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
714 umount $i
715 done
716 stdumount
717 for i in `seq 0 7`; do
718 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
719 umount /dev/loop${i} 2>/dev/null;
720 losetup -d /dev/loop${i} 2>/dev/null;
721 fi;
722 done
723 rm -rf $BASEDIR/build
724 rm -rf $BASEDIR/cdrom
f9315063 725 rm -rf $BASEDIR/packages
df5e82b3 726 rm -rf $BASEDIR/log
df5e82b3
MT
727 if [ -h /tools ]; then
728 rm -f /tools
729 fi
a50d04ab 730 beautify message DONE
df5e82b3 731 ;;
c3db995c 732downloadsrc)
df5e82b3
MT
733 if [ ! -d $BASEDIR/cache ]; then
734 mkdir $BASEDIR/cache
735 fi
736 mkdir -p $BASEDIR/log
857d9bf2 737 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
738 FINISHED=0
739 cd $BASEDIR/lfs
740 for c in `seq $MAX_RETRIES`; do
741 if (( FINISHED==1 )); then
742 break
743 fi
744 FINISHED=1
745 cd $BASEDIR/lfs
746 for i in *; do
747 if [ -f "$i" -a "$i" != "Config" ]; then
e22c7973 748 echo -ne "Loading $i"
df5e82b3
MT
749 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
750 if [ $? -ne 0 ]; then
e22c7973 751 beautify message FAIL
df5e82b3
MT
752 FINISHED=0
753 else
754 if [ $c -eq 1 ]; then
e22c7973 755 beautify message DONE
df5e82b3
MT
756 fi
757 fi
758 fi
759 done
760 done
e22c7973 761 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
762 ERROR=0
763 for i in *; do
764 if [ -f "$i" -a "$i" != "Config" ]; then
765 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
766 if [ $? -ne 0 ]; then
e22c7973
MT
767 echo -ne "MD5 difference in lfs/$i"
768 beautify message FAIL
df5e82b3
MT
769 ERROR=1
770 fi
771 fi
772 done
773 if [ $ERROR -eq 0 ]; then
e22c7973
MT
774 echo -ne "${BOLD}all files md5sum match${NORMAL}"
775 beautify message DONE
776 else
777 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
778 beautify message FAIL
df5e82b3 779 fi
e22c7973 780 cd - >/dev/null 2>&1
df5e82b3 781 ;;
df5e82b3 782toolchain)
9729e787 783 clear
df5e82b3 784 prepareenv
15679d9f 785 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
786 buildtoolchain
787 BUILDMACHINE=`uname -m`
788 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
712d859c
MT
789 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
790 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
df5e82b3
MT
791 build/{bin,etc,usr/bin,usr/local} \
792 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
793 log >> $LOGFILE
712d859c
MT
794 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
795 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
df5e82b3
MT
796 stdumount
797 ;;
798gettoolchain)
799 BUILDMACHINE=`uname -m`
800 # arbitrary name to be updated in case of new toolchain package upload
c6cb9d25 801 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
712d859c 802 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
5bd13f01 803 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
712d859c
MT
804 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
805 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
806 cd $BASEDIR/cache/toolchains
5bd13f01 807 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c
MT
808 if [ $? -ne 0 ]; then
809 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
40a4ea4c 810 else
712d859c
MT
811 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
812 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
813 else
814 exiterror "$PACKAGE.md5 did not match, check downloaded package"
815 fi
40a4ea4c 816 fi
712d859c
MT
817 else
818 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
819 fi
820 ;;
15679d9f 821othersrc)
ce56e927 822 prepareenv
15679d9f 823 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
ce56e927
MT
824 chroot $LFS /tools/bin/env -i HOME=/root \
825 TERM=$TERM PS1='\u:\w\$ ' \
826 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
827 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
828 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
829 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
15679d9f
MT
830 if [ $? -eq "0" ]; then
831 beautify message DONE
832 else
833 beautify message FAIL
834 fi
ce56e927
MT
835 stdumount
836 ;;
c6cb9d25
MT
837svn)
838 case "$2" in
839 update|up)
cc0e56be 840 # clear
15679d9f 841 echo -ne "Loading the latest source files...\n"
7471f6ab
MT
842 if [ $3 ]; then
843 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
844 else
845 svn update | tee -a $PWD/log/_build.svn.update.log
846 fi
15679d9f
MT
847 if [ $? -eq "0" ]; then
848 beautify message DONE
c6cb9d25 849 else
15679d9f 850 beautify message FAIL
c6cb9d25
MT
851 exit 1
852 fi
15679d9f 853 echo -ne "Writing the svn-info to a file"
c6cb9d25 854 svn info > $PWD/svn_status
15679d9f
MT
855 if [ $? -eq "0" ]; then
856 beautify message DONE
c6cb9d25 857 else
15679d9f 858 beautify message FAIL
c6cb9d25
MT
859 exit 1
860 fi
712d859c 861 chmod 755 $0
cc0e56be 862 exit 0
c6cb9d25
MT
863 ;;
864 commit|ci)
865 clear
6b8cff41
MT
866 if [ -f /usr/bin/mcedit ]; then
867 export EDITOR=/usr/bin/mcedit
73d9a908
MT
868 fi
869 if [ -f /usr/bin/nano ]; then
870 export EDITOR=/usr/bin/nano
6b8cff41
MT
871 fi
872 echo -ne "Selecting editor $EDITOR..."
873 beautify message DONE
d79b46cb 874 if [ -e /sbin/yast ]; then
028698e8
MT
875 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
876 $0 changelog
877 fi
d79b46cb 878 fi
15679d9f 879 svn commit
c6cb9d25 880 $0 svn up
6b8cff41 881 $0 uploadsrc
c6cb9d25
MT
882 ;;
883 dist)
7471f6ab
MT
884 if [ $3 ]; then
885 SVN_REVISION=$3
886 fi
887 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
888 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
889 exit 0
890 fi
891 echo -en "REV $SVN_REVISION: Downloading..."
9729e787
MT
892 svn export http://svn.ipfire.eu/svn/ipfire/trunk ipfire-source/ --force > /dev/null
893 svn log http://svn.ipfire.eu/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
894 #svn info http://svn.ipfire.eu/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
15679d9f
MT
895 evaluate 1
896
7471f6ab
MT
897 echo -en "REV $SVN_REVISION: Compressing files..."
898 if [ -e ipfire-source/trunk/make.sh ]; then
899 chmod 755 ipfire-source/trunk/make.sh
900 fi
9dc02b38 901 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
15679d9f 902 evaluate 1
7471f6ab 903 echo -en "REV $SVN_REVISION: Cleaning up..."
c6cb9d25 904 rm ipfire-source/ -r
15679d9f 905 evaluate 1
7471f6ab 906 ;;
028698e8 907 diff|di)
15679d9f 908 echo -ne "Make a local diff to last svn revision"
c6cb9d25 909 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
15679d9f 910 evaluate 1
c6cb9d25
MT
911 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
912 ;;
913 esac
f9315063 914 ;;
15679d9f
MT
915uploadsrc)
916 PWD=`pwd`
917 cd $BASEDIR/cache/
918 echo -e "Uploading cache to ftp server:"
71e32384 919 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /var/tmp/ftplist
15679d9f 920 for i in *; do
f59e1e88 921 if [ "$i" == "toolchains" ]; then continue; fi
15679d9f 922 grep -q $i /var/tmp/ftplist
0eab8e84 923 if [ "$?" -ne "0" ]; then
15679d9f 924 echo -ne "$i"
71e32384 925 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
0eab8e84 926 if [ "$?" -eq "0" ]; then
15679d9f 927 beautify message DONE
0eab8e84 928 else
15679d9f 929 beautify message FAIL
0eab8e84
MT
930 fi
931 fi
932 done
15679d9f 933 rm -f /var/tmp/ftplist
15679d9f
MT
934 cd $PWD
935 exit 0
0eab8e84 936 ;;
cc0e56be
MT
937upload)
938 case "$2" in
939 iso)
940 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
9dc02b38
MT
941 cat <<EOF > .ftp-commands
942mkdir $IPFIRE_FTP_PATH_EXT
943ls -lah
944quit
945EOF
946 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
947 rm -f .ftp-commands
948 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
71e32384
MT
949 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso
950 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso.md5
951 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-source-r$SVN_REVISION.tar.gz
952 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ svn_status
9dc02b38
MT
953 if [ "$?" -eq "0" ]; then
954 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
cc0e56be 955 else
9dc02b38
MT
956 echo -e "There was an error while uploading the iso to the ftp server."
957 exit 1
cc0e56be 958 fi
6aae8d61 959 if [ "$3" = "--with-sources-cd" ]; then
71e32384 960 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-sources-cd-$VERSION.$MACHINE.iso
6aae8d61 961 fi
cc0e56be
MT
962 ;;
963 paks)
9dc02b38
MT
964 cat <<EOF > .ftp-commands
965mkdir $IPFIRE_FTP_PATH_PAK
966ls -lah
967quit
968EOF
969 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
970 rm -f .ftp-commands
cc0e56be
MT
971 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
972 if [ "$?" -eq "0" ]; then
9dc02b38 973 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
cc0e56be
MT
974 else
975 echo -e "There was an error while uploading the packages to the ftp server."
712d859c 976 exit 1
cc0e56be
MT
977 fi
978 ;;
979 esac
0d0521b6 980 ;;
cc0e56be 981batch)
15679d9f
MT
982 if [ "$2" -eq "--background" ]; then
983 batch_script
984 exit $?
985 fi
27ac55bf 986 if [ `screen -ls | grep -q ipfire` ]; then
712d859c
MT
987 echo "Build is already running, sorry!"
988 exit 1
989 else
27ac55bf
MT
990 if [ "$2" = "--rebuild" ]; then
991 export IPFIRE_REBUILD=1
992 echo "REBUILD!"
993 else
994 export IPFIRE_REBUILD=0
995 fi
15679d9f
MT
996 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
997 screen -dmS ipfire $0 batch --background
998 evaluate 1
712d859c
MT
999 exit 0
1000 fi
cc0e56be 1001 ;;
028698e8 1002watch)
15679d9f 1003 watch_screen
028698e8 1004 ;;
33634aa8
MT
1005pxe)
1006 case "$2" in
1007 start)
1008 start_tftpd
1009 ;;
1010 stop)
1011 stop_tftpd
1012 ;;
a50d04ab 1013 reload|restart)
33634aa8
MT
1014 reload_tftpd
1015 ;;
1016 esac
1017 exit 0
1018 ;;
6b8cff41 1019"")
24a4a744
MT
1020 clear
1021 svn info
c3db995c 1022 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
24a4a744
MT
1023 do
1024 case $name in
c3db995c
MT
1025 "IPFIRE: Downloadsrc")
1026 $0 downloadsrc
c6cb9d25
MT
1027 ;;
1028 "IPFIRE: Build (silent)")
1029 $0 build-silent
1030 ;;
1031 "IPFIRE: Watch Build")
028698e8 1032 $0 watch
c6cb9d25 1033 ;;
712d859c
MT
1034 "IPFIRE: Batch")
1035 $0 batch
1036 ;;
c6cb9d25
MT
1037 "IPFIRE: Clean")
1038 $0 clean
1039 ;;
c6cb9d25
MT
1040 "SVN: Update")
1041 $0 svn update
1042 ;;
c6cb9d25 1043 "Help")
a50d04ab 1044 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
c6cb9d25
MT
1045 cat doc/make.sh-usage
1046 ;;
712d859c
MT
1047 "LOG: Tail")
1048 tail -f log/_*
1049 ;;
c6cb9d25
MT
1050 "Exit")
1051 break
1052 ;;
24a4a744
MT
1053 esac
1054 done
df5e82b3 1055 ;;
a50d04ab
MT
1056config)
1057 make_config
1058 ;;
6b8cff41 1059*)
a50d04ab 1060 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1061 cat doc/make.sh-usage
1062 ;;
3ea75603 1063esac